% Clear the memory
clear all;

% Load the (sampled) data & constants (SBOX and HW)
load('attack_data_2.mat');
load('constants.mat');


% Set the keybytes the trigger was set for 
keybyte_1 = ???;
keybyte_2 = ???; %AES operated on the state column-wise

% Set the range of oscilloscope samples to attack
datapoints = datapoints;
samples = size(datapoints,1);


% Copy the relevant plaintexts byte(s) in 2 new arrays D_1, D_2
display('Calculating D...')
display('Calculating D...')
D_1 = uint8(???);
D_2 = uint8(???);

% Generate vector K for values close to the key
% The whole range cannot be examined by this simple script
CORRECT_KEY_1 = 252; 
CORRECT_KEY_2 =  45;
K = ([???]); %Create a table that contains the CORRECT_KEY_1 and CORRECT_KEY_2, as well as several "neighbor" values


% Copy the relevant traces and sample points in a new array T
display('Calculating T for keybytes...')

T = datapoints(1:samples,:);
T = T(:, [??? ???]); %%Trimming the traces for testing


% Power traces preprocessing, using absolute different method
for k = 1:samples
    b = (nchoosek(???); %Find all combinations of the traces, taking 2 at a time
    c(k,:) = (???); %Find the absolute difference of b(:,1),b(:,2)
end
T = (double(c));
clear k c b

% You can create a one-line solution, or split the computation to separate
% loops

for ikey = 1:size(K,1)
        S1(:,ikey) = ??? .'; % Keep the transpose
        S2(:,ikey) = ??? .';
end 

for ikey = 1:size(K,1)
        H(:,ikey) = HW(bitxor(???,???)+1);
end 

% Create matrix R to save the correlation results
% R has rows equal to the number of points
% R has columns equal to the number of possible key bytes

trace_length = size(T, 2);
R = zeros(trace_length, length(K));

% Calculate the correlation
display('Calculating R...')

% Apply Pearson's Correlation
% H needs to be double
H = double(H);
R = corr(T,H,'Type','Pearson');%'Pearson', 'Kendall', 'Spearman'

r = abs(R);
max_correlation = max(max(r.'));
[max_correlation_index,max_leakage_point]=find(r.'==max_correlation);
key_1_value = ???
key_2_value = ???

%result{1,5} = key_found;
figure;
plot(R.');

% clearvars -except datapoints plaintexts_SCA result HW SubBytes



